/*
 * receiver.c
 *
 * receive a file from server.
 *
 *  Created on: 2018. 5. 12.
 *      Author: minseo
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#define BUFSIZE 1024

int SocketOpen(int socket_fd);
struct sockaddr_in SocketConnect(int socket_fd, struct sockaddr_in server_addr);
void FileReceive(int socket_fd);

void main() {
    int socket_fd;
    struct sockaddr_in server_addr;

    socket_fd = SocketOpen(socket_fd);
    server_addr = SocketConnect(socket_fd, server_addr);
    FileReceive(socket_fd);
    close(socket_fd);
}

// client socket 생성
int SocketOpen(int socket_fd) {
    if ((socket_fd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
        perror("socket open error.");
        exit(1);
    }
    return socket_fd;
}

// client가 server 소켓에 연결 요청
struct sockaddr_in SocketConnect(int socket_fd, struct sockaddr_in server_addr) {
    memset(&server_addr, 0, sizeof(server_addr));
    server_addr.sin_family = AF_INET;
    server_addr.sin_addr.s_addr = inet_addr("192.168.56.101");
    server_addr.sin_port = htons(50000);

    if (connect(socket_fd, (struct sockaddr*) &server_addr, sizeof(server_addr)) == -1) {
        perror("socket connect error.");
        exit(1);
    }

    return server_addr;
}

// server로 부터 파일 전송 받음
void FileReceive(int socket_fd) {
    FILE* receive_fp;
    char send_buf[BUFSIZE] = { '\0', };
    char receive_buf[BUFSIZE] = { '\0', };
    int receive_size = 0;
    int write_size = 0;
    int file_size = 0;
    int total_write_size = 0;

    // 1. 파일을 쓰기 모드로 염
    if ((receive_fp = fopen("speech", "w")) == NULL) {
        perror("receive file open error.");
        exit(1);
    }

    // 2. 전송 받을 파일 전체 사이즈를 전송 받음.
    if ((receive_size = recv(socket_fd, &file_size, sizeof(file_size), 0)) == -1) {
        perror("file receive error.");
        exit(1);
    }
//    printf("size:%d\n", file_size);

// server로부터 데이터를 받아 파일에 씀
    while (1) {
        memset(receive_buf, 0, BUFSIZE);

        //  3. server로 부터 데이터를 전송 받음
        if ((receive_size = recv(socket_fd, receive_buf, BUFSIZE, 0)) == -1) {
            perror("file receive error.");
            exit(1);
        }
//        receive_buf[strlen(receive_buf) - 1] = '\0';
//        printf("string print :%s \n", receive_buf);
//        printf("receive_size:%d , %d \n", receive_size, strlen(receive_buf));

        // 4. server로부터 더이상 전송 받은 데이터가 없으면 while문 종료.
        if (receive_size == 0) {
            // 만약 전송 받은 파일 전체 사이즈와 server의 파일 전체사이즈가 다르면 파일 삭제 - 실패 !
            if (file_size != total_write_size) {
                remove("speech");
            }

            break;
        }

        // 5. 전송 받은 데이터를 char 크기만큼 파일에 씀
        write_size = fwrite(receive_buf, sizeof(char), receive_size, receive_fp);

        total_write_size += write_size;
        printf("write_size:%d \n", write_size);

        // 6. 전체 받은 데이터 사이즈와 전송 받을 파일 전체 사이즈가 같으면 while문 종료 - 성공 !
        if (file_size == total_write_size) {
            break;
        }
    }
    printf("total_write_size:%d \n", total_write_size);

    fclose(receive_fp);
}
